<?php
/*
  Copyright (c) 2008-2010, Xavier 'Xr' Dalem
  This file is part of Java API Browser

  Version 1.1

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

error_reporting(E_ALL|E_NOTICE);

define('CACHE_DIR', './cache');
define('CACHE_BASE_NAME', CACHE_DIR.'/java-api-browser-');
define('CACHE_LIFE', 60*60*24); // in seconds
$cacheAvailable = (is_dir(CACHE_DIR) && is_writable(CACHE_DIR)) || @mkdir(CACHE_DIR);

?>
<?php
if (isset($_GET['q'])) {
	//$_GET['q'] = 'abstract'; // test
	//$_GET['source'] = 'http://java.sun.com/javase/6/docs/api/'; // test
	//$_GET['source'] = 'http://www.jajakarta.org/ant/ant-1.6.1/docs/ja/manual/api/'; // Test with other formatting
	
	header('Content-type: text/plain');
	
	$baseUrl = $_GET['source'];
	$indexUrl = $baseUrl.'allclasses-frame.html';

	// Cache results of the classes list
	$candidateFile = CACHE_BASE_NAME.md5($indexUrl);
	if ($cacheAvailable
			&& file_exists($candidateFile)
			&& (time() - filemtime($candidateFile) < CACHE_LIFE)) {
		// using cache
		$source = file_get_contents($candidateFile);
	} else {
		// refreshing cache
		$source = file_get_contents($indexUrl);
		if ($cacheAvailable)
			file_put_contents($candidateFile, $source);
	}
	
	// Sample: <A HREF="javax/swing/border/AbstractBorder.html" title="class in javax.swing.border" target="classFrame">AbstractBorder</A>
	// In some version, the package might be missing
	$regex = '|<a href="([^"]*)" (title="[^"]* in ([^"]*)" )?target="[^"]*">([^"]*)</a>|iU';
	$numMatches = preg_match_all($regex, $source, $matches);
	
	// Detect regular expressions
	$isRegex = $_GET['q'][0] == '$';
	if ($isRegex)
		$_GET['q'] = '/'.substr($_GET['q'], 1).'/i';
	
	for ($i = 0; $i < $numMatches; $i++) {
		if ($isRegex
				?(preg_match($_GET['q'], $matches[4][$i]) > false)
				:(stripos($matches[4][$i], $_GET['q']) !== false))
			echo "{$matches[4][$i]}|{$matches[3][$i]}|{$baseUrl}{$matches[1][$i]}\n";
	}
	
	exit();
}

	if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') === false)
		echo '<?xml version="1.0" encoding="UTF-8"?>'."\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		<link rel="stylesheet" type="text/css" href="java-api-browser.css" />
		<script type="text/javascript" src="jquery.js"></script><!-- © 2008 John Resig, dual licensed under GNU General Public License v2 and MIT License -->
		<script type="text/javascript" src="jquery.autocomplete.js"></script><!-- © 2007 Dylan Verheul, Dan G. Switzer, Anjesh Tuladhar, Joern Zaefferer, dual licensed under GNU General Public License and MIT License -->
		<script type="text/javascript" src="jquery.hotkeys.js"></script><!-- © 2007-2008 Tzury Bar Yochay, released under MIT License -->
		<script type="text/javascript" src="java-api-browser.js"></script>
		<title>Java API browser</title>
		<script type="text/javascript">
//<![CDATA[
$(function() {
	// Hide info box and custom box
	$('fieldset#info').hide();
	$('fieldset#customize').hide();
	
	// Load options
	var jabOptions = getJABOptions();
	for (var i=0; i < jabOptions.length; i++)
		$('select#source').append('<option value="'+jabOptions[i].url
			+'" '+(i==0?'selected="selected"':'')+'>'+jabOptions[i].name+'</option>');
	
	// Configure autocompletion
	$("input#query").autocomplete(location.href, {
		extraParams: {
			source: function() { return $("select#source").val();  }
		},
		formatItem: function(item) {
			var fmt = item[0];
			if (item[1].length > 0)
				fmt += ' <em>('+item[1]+')</em>';
			return fmt;
		},
		minChars: 2,
		max: 50
	}).result(function(event, item) {
		// Strip tags when setting the value in the textbox. Just to be pretty, it
		// doesn't change anything (doing this now leaves interfaces in italic).
		$("input#query").val(item[0].replace(/<[^>]+>/g, ''));
		// Go to given URL
		location.href = item[2];
	});
	
	// Focus the field for immediate use
	$("input#query").focus();
	
	// Load options for customization
	var options = getJABOptions()
	loadOptions(options);
	
	// Refresh cookie
	writeJABOptions(options);
	
	// Shortcut to change API
	$(document).bind('keydown', 'Alt+a', switchAPI);
});
// ]]>
		</script>
	</head>
<body>
<?php
if (!$cacheAvailable)
	echo '<div class="warning">Could not access or create cache directory. Performance will be highly degraded</div>';
?>
<form action="" method="post">
	<fieldset>
		<div id="tools">
			<span onclick="$('fieldset#customize').show('medium');">+</span>
			<span onclick="$('fieldset#info').show('medium');">?</span>
		</div>
		<legend>Browse Java API</legend>
		<label for="source">Version:</label>
		<select name="source" id="source">
			<!-- to be filled automatically -->
		</select><br />
		<label for="query">Class:</label>
		<input type="text" name="query" id="query" value=""/>
	</fieldset>
</form>

<form action="" method="post">
	<fieldset id="customize">
		<legend>Customize</legend>
		<input type="button" class="button" value="+"            onclick="addOption()" id="adder" />
		<input type="button" class="button" value="Save"         onclick="saveOptions()" />
		<input type="button" class="button" value="Cancel"       onclick="loadOptions(getJABOptions())" />
		<input type="button" class="button" value="Get defaults" onclick="loadOptions(getDefaultJABOptions())" />
	</fieldset>
</form>

<fieldset id="info"><legend>Info</legend><ul>
	<li>You can use regular expressions to match classes. Just type <em>$</em>
	followed by your expression. Delimiters (<em>slashes</em>) are added
	automatically and matches will be case-insensitive.</li>
	
	<li>Alt+A switches the API</li>
	
	<li>When customizing the choices, "Get defaults" does not save them, so
	that you can restore your choices if you happen to click it by mistake.</li>
	
	<li>You can add addresses of password-protected pages by specifying the
	login and password in the URL (e.g.
	<tt>http://login:password@example.com/api/</tt>). Paranoids beware: since
	cookies are usually stored in plaintext by browsers, your password could be
	be readable by anyone who has an access to your computer. You also
	acknowledge that the server showing you this API browser will have access
	to your password (but will not keep it) and will cache the previously
	protected result page.</li>
</ul></fieldset>
</body>
</html>
